/*
   Name: old-stream.h
   Language: ANSI/ISO C

   Purpose: An attempt encapsulate an abstract data type (namely a stream) 
            using C.  

   Author: James Blustein <jamie@csd.uwo.ca>
   Created: 1 January 1996
   Last Modified: 21 April 1996 by James Blustein

   See also: stream.c
*/

#include <stdio.h>

/* Definition of opaque File_t datatype */
typedef struct File_t {
   FILE * (* open)(const char * proc, const char * fname, const char * mode);
   bool (* close)(const char * proc, const char * fname, FILE * handle);
} File_t;

/* Import definition of type File from "file.c" */
extern File_t Stream;

/* end of "stream.h" */
